#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>

#define PRIORITY_PORT 20000	
#define ROUTINE_LISTEN_PORTS 5

#define EVER ;;

struct big {
  int numbers[350];
  int send_value;
};

int main(void) {
	int i = 0;
	int j = 0;	
	int rx = 0;
  struct big send_big;

   /* for select */
  struct timeval stv;
  fd_set master; 
  fd_set read_fds;
  int fd_max;     
  int select_return;

	int priority_socket;
	int routine_sockets[ROUTINE_LISTEN_PORTS];
	
	struct sockaddr_in my_addr;	
	struct sockaddr_in their_addr;
	struct sockaddr_in dummy_addr;	
	socklen_t addr_len;

  /* for setsockopt */
  int send_tos = IPTOS_PREC_PRIORITY;
  
  /* for send */
  int send_count = 0;
  unsigned int send_flags = 0;

	my_addr.sin_family = AF_INET;		 /* host byte order */
	my_addr.sin_port = htons(PRIORITY_PORT);	 /* short, network byte order */
	my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */
	memset(my_addr.sin_zero, '\0', sizeof my_addr.sin_zero);

	if ((priority_socket = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	if (bind(priority_socket, (struct sockaddr *)&my_addr, sizeof my_addr) == -1) {
		perror("bind");
		exit(1);
	}

  /* SETSOCKOPT() - TOS */
  if( setsockopt(priority_socket, IPPROTO_IP, IP_TOS, &(send_tos), (socklen_t) sizeof(send_tos) ) == -1){
    perror("setsockopt");
    exit(1);
  }  	
	
	for(i=0; i<ROUTINE_LISTEN_PORTS ; i++){
	  if ((routine_sockets[i] = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		  perror("socket");
		  exit(1);
	  }
  
  	my_addr.sin_port = htons(PRIORITY_PORT+1+i);	 /* short, network byte order */
	  if (bind(routine_sockets[i], (struct sockaddr *)&my_addr, sizeof my_addr) == -1) {
		  perror("bind");
		  exit(1);
	  }	  
	}

  system("clear");
  /*  printf("Sizeof big: %d\n",sizeof send_big);*/

	addr_len = sizeof dummy_addr;

  /* SELECT() */
  stv.tv_sec = 30;
  stv.tv_usec = 0;  
  FD_ZERO(&read_fds);
  FD_ZERO(&master);

  FD_SET(priority_socket,&master);
  fd_max = priority_socket;
	for(i=0; i<ROUTINE_LISTEN_PORTS ; i++){
	  FD_SET(routine_sockets[i],&master);
    fd_max = (routine_sockets[i]>fd_max) ? routine_sockets[i] : fd_max;
	}
  printf("Init done, entering selective receive loop.\n");
  for(EVER){
    read_fds = master; 
    select_return = select(fd_max+1, &read_fds, NULL, NULL, &stv);
    if (select_return == -1) {
      perror("select");
      exit(1);
    }
    else if(select_return == 0){
      printf("Select timeout\n");
      break;
    }
    else {
      /* RX */
    }

    /* run through the existing connections looking for data to read */
    for(i = 0; i <= fd_max; i++) {
      if (FD_ISSET(i, &read_fds)) { 
        if(i==priority_socket){
          if(recvfrom(priority_socket, &send_big, sizeof(send_big) , 0, (struct sockaddr *)&dummy_addr, &addr_len) <= 0){
            perror("recv");
            FD_CLR(i, &master);
          }
          else {
            rx++;
            for(j=0; j<ROUTINE_LISTEN_PORTS ; j++){
            	their_addr.sin_port = htons(PRIORITY_PORT+1+j);	 /* short, network byte order */              
              send_count = sendto(routine_sockets[j], &send_big, sizeof(send_big), send_flags, 
                                  (struct sockaddr*)&their_addr, (socklen_t) sizeof(their_addr) );
              if( send_count <= 0){
                perror("sendto");
                exit(1);
              }
            }
          } 
        } /* if i == priority_socket */
        else {
          if(recvfrom(i, &send_big, sizeof(send_big) , 0, (struct sockaddr *)&their_addr, &addr_len) <= 0){
            perror("recv");
            FD_CLR(i, &master);
          }
          else {
            rx++;
          } 

        } /* else (/ if i == routine_socket) */ 

      } /* if FD_ISSET(i, &read_fds) */

    } /* for i in fd_max */

  } /* for EVER */

  printf("Receiver done: received %d packets.\n",rx);

	close(priority_socket);

	return 0;
}
